/************************************************************************************************
    v.20131231JC FIXED duplicate drawer slideout for keyboard navigation
    v.20131230JC FIXED selector error in IE7 + 8 for keyboard navigation
    v.20131223JC getting selector error in IE7 + 8 for keyboard navigation first/last-of-type
    v.20131213JC added a11y aria attributes
    mega-dd reskinned 8/2013 
    Added menuAim for submenu hover intention, added dd-pull-right class to #topnav > li .sub

************************************************************************************************/

jQuery(document).ready(function ($) {

  // MEGA MENU
  var $topnav = $("#topnav"),
      topnav_anchors = "#topnav .nav_label > a",
      $topnav_anchors = $(topnav_anchors), //target top tab and 'more' anchors
      submenu_direction = "right",
      dd_drawer_background = $('.dd-drawer').css('backgroundColor'),
      topnav_width = $('#topnav').outerWidth(),
      kb = false;

  // add dd-pull-right class to middle li -> last li in #topnav 
  // (to avoid sub menu opening outside of the main content div)  
  $("#topnav > li").each(function() {
    var li_pos = $(this).position(),
        li_width = $(this).outerWidth(),
        sub_left = -Math.abs(470 - li_width);

    //$(this).attr('role','presentation');
        
    if ( li_pos.left >= ( topnav_width / 2 ) ) {
      $(this).find('.sub').addClass("dd-pull-right");
      
      if ( $('html.lt-ie8').length > 0 ) {
        $(this).find('.sub').css({
          'left': sub_left+'px'
        });
      }      
    }

    //Accessibility attributes
    $(this).find('a.tab').attr({
      //'aria-expanded': 'false',
      //'aria-haspopup': 'true',
      'aria-owns': 'sub' + $(this).index(),
      'aria-controls': 'sub' + $(this).index()
    })
  });
    
  $("#topnav > li .sub").each(function() {
    var numLis = $(this).find('> .category > ul > li').size(),
    subId = $(this).closest('.menu').find('a.tab').attr('aria-controls');

    //Used for accessibility attribute aria-owns + aria-controls
    $(this).attr({
      'id': subId
      //'aria-hidden': 'true',
      //'role': 'presentation'
    });
    
    // add class to assign (in css) min-height of .dd-drawer based on #lis
    if ( numLis == 0 ) {
      $(this).parent().addClass('noDrawer');    
      $(this).find('.dd-drawer').css('display','none');      
    }
    //$(this).find('.category').attr('role','presentation');
    $(this).find('.dd-drawer').addClass('items-'+numLis);//.attr('role','presentation');

    $('.category-drop-li').each(function() {
      if ( $(this).find('.subcat').length == 0 ) {
        $(this).addClass('no-sub');                
      }
    });  
  });

  var showSub = function () {

    var $tab = $(this),
        $sub = $tab.find(".sub"),
        $drop = $sub.find(".category"),
        $dropmenu = $sub.find(".category-drop"),
        $dropli = $drop.find(".category-drop-li"),
        $drawer = $sub.find(".dd-drawer"),
        $dropLiFirst = $dropli.first(),                
        lis = $dropli.size(),        
        drawerHeight,                
        categoryHeight = (45 * lis) + 2,        
        shadowTop = -Math.abs(categoryHeight), 
        drawerShadowTop = shadowTop * 2,
        tab_pos = $tab.position(),
        boxShadowPX,
        catShadowTop,
        borderRadius;  

    $tab.find('.tab').attr('aria-expanded','true');
                
    $sub.fadeIn("fast", function () {
      $sub.addClass('active').css({
          'overflow': 'visible',
          'opacity': 1
        }).show().attr('aria-hidden','false');
    });  

    if ($sub.is(":visible")) {  

      var $firstSubcat = $dropLiFirst.find('.subcat'),  
        theHeight = $firstSubcat.height(),
        $briefContent = $sub.find('.brief-content'),
        has_brief_content = $briefContent.length;     

      $drop.slideDown(100, function() {
        $drop.css({'overflow':'visible'});            

        

        //$sub.delay(0).queue( function(next){
        //if ( $dropmenu:has('.dd-active') )
        var active = $dropmenu.children().hasClass('dd-active');
        if ( active ) {
            //console.log('active + kb:'+kb);
            $dropLiFirst.removeClass("dd-active active-on");
          
          if ( $firstSubcat.length > 0 ) {                                    
            $firstSubcat.css({
              top: '-99999em'
            });         
          }
        }
        else {
          //console.log('not active + kb:'+kb);

          $dropLiFirst.addClass("dd-active active-on");
          
          if ( $firstSubcat.length > 0 ) {                                    
            $firstSubcat.delay(200).queue(function(next) {
                $(this).css({
                  top: '0'
                });
                next();
            });         
          }
        }
        //next();
        //});
         
      });
     
      if ( $firstSubcat.length > 0 ) {
        // 3rd level present so open drawer (to left for .dd-pull-right or right for regular)
        // and apply shadows           
        
        if ( $sub.hasClass('dd-pull-right') ) { 
          submenu_direction = "left";
          if ( $('html.lt-ie8').length > 0 ) {
            $drawer.show().css({ left: 250 }).animate({ left: -28 }, 250);
          }
          else {
            $drawer.show().css({ left: 250 }).animate({ left: 0 }, 250);
          }                                           
        }//if dd-pull-right
        else {
          submenu_direction = "right";
          if ( $('html.lt-ie9').length > 0 ) {
            $drawer.show().css({ left: 0 }).animate({ left: 216 }, 250);          
          }
          else {
            $drawer.show().css({ left: 0 }).animate({ left: 215 }, 250);          
          }
        }//else 

        if ( has_brief_content ) {
          drawerHeight = theHeight + $sub.find('.brief-content').height() + 55;     
        }
        else {
          drawerHeight = theHeight + 30;                    
        }  
            
        $drawer.height( drawerHeight ); 
        drawerHeight = $drawer.outerHeight();
        //console.log('drawer Height: '+theHeight+' + '+$sub.find('.brief-content').height()+' + 55/30 = '+drawerHeight);

        // apply box shadows
        if ( $sub.hasClass('dd-pull-right') ) {
            boxShadowPX = '5px 7px 17px -4px';
            catShadowTop = '0px';
            if ( $('html.lt-ie8').length > 0 ) {
              drawerShadowTop = shadowTop - 20;
              drawerShadowTop = drawerShadowTop+'px';
            }
            else {
              drawerShadowTop = shadowTop+'px';
            }
            //alert(drawerShadowTop);
          }
          else {
            boxShadowPX = '-5px 7px 17px -4px';
            catShadowTop = shadowTop+'px';            
            if ( $('html.lt-ie8').length > 0 ) {
              drawerShadowTop = drawerShadowTop - 20;
            }
            drawerShadowTop = drawerShadowTop+'px';
          }

        $sub.delay(100).queue( function(next){
          $drop.css({ 
            'box-shadow' : 'rgb(125, 125, 125) '+boxShadowPX,
            '-moz-box-shadow' : 'rgb(125, 125, 125) '+boxShadowPX,
            '-webkit-box-shadow' : 'rgb(125, 125, 125) '+boxShadowPX 
          }); 
          if ( $('html.lt-ie9').length > 0 ) {
            if ( $sub.find('.category-shadow').length == 0 ) {
              $('<div class="category-shadow"></div>').insertAfter($sub.find('.category'));
              if ( $('html.lt-ie8').length > 0 && $sub.hasClass('dd-pull-right') ) {
                categoryHeight = categoryHeight + 10;
              }
              $('.category-shadow').height(categoryHeight).css({
                'top': catShadowTop
              });
            }
            if ( $sub.find('.drawer-shadow').length == 0 ) {              
              $('<div class="drawer-shadow"></div>').insertAfter($sub.find('.category-shadow'));
              $('.drawer-shadow').height(drawerHeight);
                $('.drawer-shadow').css({
                  'top': drawerShadowTop
                });
            }
          }           
          $drawer.css({
            'box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px',
            '-moz-box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px',
            '-webkit-box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px' 
          });          
          next(); 
        });  
      
      } // if dropli.first.find.subcat
      else { // no .subcat

        //close and add closed class
        //if ( $sub.hasClass('dd-pull-right')) {
          $drawer.addClass('drawer-closed').fadeTo(0,0);          

       // }//if dd-pull-right
       // else {
       //   $drawer.addClass('drawer-closed').fadeTo(0,0);          
       // }//else

        // apply box shadows
        $sub.delay(100).queue( function(next){    
          
          $drop.css({             
            'box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px',
            '-moz-box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px',
            '-webkit-box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px',
            'border-radius' : '0 0 5px 5px'
          }).find('.category-drop-li:last').css({ 'border-radius' : '0 0 5px 5px'});            
         
          $drawer.css({
            'box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px',
            '-moz-box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px',
            '-webkit-box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px' 
          });

          if ( $('html.lt-ie9').length > 0 ) {
            if ( $sub.hasClass('dd-pull-right')) {              
              catShadowTop = '0';
            }
            else {
              catShadowTop = shadowTop;
            }
            if ( $sub.find('.category-shadow').length == 0 ) {
              $('<div class="category-shadow"></div>').insertAfter($sub.find('.category'));
              if ( $('html.lt-ie8').length > 0 && $sub.hasClass('dd-pull-right') ) {
                categoryHeight = categoryHeight + 10;
              }
              $('.category-shadow').height(categoryHeight).css({
                'top': catShadowTop
              });
            }
          }

          next(); 
        });
      }// else - no .subcat
               

        //.menuAim makes 3rd level UL appear to left/right with hover intent triangle
        // https://github.com/kamens/jQuery-menu-aim
        if( $drop.find('.category-drop').length > 0 ) {
          $drop.find('.category-drop').menuAim({
            activate: function(row) {
              var $row = $(row),
                $submenu = $row.find(".subcat"),   
                //$drawer = $sub.find(".dd-drawer"),           
                //drawerHeight = 0,
                $iconStack = $row.find(".fa-stack"),
                IE_ddDrawerHeight, IE7_ddDrawerHeight,
                $top = 45 - (45 * ($row.index()+1));  // change 45 to li height                 
                //console.log($top);
              
              //Drawer LOGIC
              // no sub
              if ( $row.hasClass('no-sub') ) {
                // move subcat to top -- necessary?
                $('.subcat').css({ top: "-99999em" }); 
                
                //apply shadow to 2nd level
                $drop.css({ 
                  'box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px',
                  '-moz-box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px',
                  '-webkit-box-shadow' : 'rgb(125, 125, 125) 5px 7px 17px -4px, rgb(125, 125, 125) -5px 7px 17px -4px',
                  'border-radius' : '0 0 5px 5px'
                }).find('.category-drop-li:last').css({ 'border-radius' : '0 0 5px 5px'});              

                if ( $drawer.hasClass('drawer-closed') ) {
                  //do nothing already closed                
                }
                else {
                  //close and add closed class
                  //if ( $sub.hasClass('dd-pull-right')) {
                    $drawer.fadeTo( 0, 0 ).addClass('drawer-closed');
                    $sub.find('.drawer-shadow').hide();
                 // }//if dd-pull-right
                 // else {
                  //  $sub.find(".dd-drawer").fadeTo( 0, 0 ).addClass('drawer-closed');          
                 // }//else               
                }
              }//end if no subcat
              // has subcat
              else {
                
                //console.log('has sub');
                // Show the drawer + submenu              
                theHeight = $submenu.height();              
                if ( has_brief_content ) {
                  drawerHeight = theHeight + $submenu.closest('.sub').find(".brief-content").height() + 55;
                }
                else {
                  drawerHeight = theHeight + 30;                    
                }

                $sub.find(".dd-drawer").height( drawerHeight );
                //console.log('drawer Height: '+theHeight+' + '+$submenu.closest('.sub').find(".brief-content").height()+' + 55/30 = '+drawerHeight);

                IE_ddDrawerHeight = $sub.find(".dd-drawer").height() + 21;
                IE7_ddDrawerHeight = $sub.find(".dd-drawer").height() + 23;
                //console.log('drawer height: '+drawerHeight);
                if ( $('html.lt-ie9').length > 0 ) {
                    $sub.find('.drawer-shadow').height(IE_ddDrawerHeight);
                  }    
                if ( $('html.lt-ie8').length > 0 ) {
                    $sub.find('.drawer-shadow').height(IE7_ddDrawerHeight);
                  }    

                if ( $sub.hasClass('dd-pull-right') ) {
                  boxShadowPX = '5px 7px 17px -4px';
                  borderRadius = '0 0 5px 0';
                }
                else {
                  boxShadowPX = '-5px 7px 17px -4px';
                  borderRadius = '0 0 0 5px';
                }
                $drop.css({ 
                  'box-shadow' : 'rgb(125, 125, 125) '+boxShadowPX,
                  '-moz-box-shadow' : 'rgb(125, 125, 125) '+boxShadowPX,
                  '-webkit-box-shadow' : 'rgb(125, 125, 125) '+boxShadowPX,
                  'border-radius' : borderRadius
                }).find('.category-drop-li:last').css({ 'border-radius' : borderRadius });             
                            
                if ( $drawer.hasClass('drawer-closed') ) {
                  //remove class and open
                  //if ( $sub.hasClass('dd-pull-right')) {
                    $drawer.fadeTo( 0, 1, function() {
                      // Animation complete.
                      //$submenu.css({'top':$top+"px"});
                      if ( $('html.lt-ie9').length > 0 ) {                      
                        //var categoryHeight = $sub.find('.category').outerHeight(),
                          //shadowTop = 0 - categoryHeight, 
                          //drawerShadowTop = shadowTop * 2,         
                          //drawerHeight = $sub.find('.dd-drawer').outerHeight(),
                          //IE_ddDrawerHeight = $sub.find(".dd-drawer").height() + 21;

                        if ( $sub.find('.drawer-shadow').length == 0 ) {
                          $('<div class="drawer-shadow"></div>').insertAfter($sub.find('.category-shadow'));                        
                          if ( $sub.hasClass('dd-pull-right')) {
                            $('.drawer-shadow').height(IE_ddDrawerHeight).css({
                              'top': shadowTop+'px'
                            });
                          }
                          else {
                            $('.drawer-shadow').height(IE_ddDrawerHeight).css({
                              'top': drawerShadowTop+'px'
                            });
                          }
                        }
                        else {
                          $sub.find('.drawer-shadow').show();
                          $sub.find('.drawer-shadow').height(IE_ddDrawerHeight);
                        }
                      }
                      
                      
                    });                                 
                  //}//if dd-pull-right
                  //else {
                    //$sub.find(".dd-drawer").fadeTo( 0, 1, function() {
                      // Animation complete.
                      //$submenu.css({'top':$top+"px"});
                    //});                  
                  //}//else
                  $drawer.removeClass('drawer-closed');                              
                }
                else {
                  // do nothing because it's open and it needs to be
                  //$submenu.css({'top':$top+"px"});
                }              
                
                $submenu.css({'top':$top+"px"});
              }             
              /*var delay = 10;              
              if ( $('html.lt-ie9').length > 0 ) {
                delay = 0;
              }
              //console.log(delay);*/
              // Keep the currently activated row's highlighted look
              $row.addClass("dd-active active-on")/*.delay(delay)
                       .queue(function() {
                           $(this).addClass("active-on");
                           $(this).dequeue();
                       })*/;

              // change drawer background color to list-container bg color
              if ( $row.hasClass('list-container-content') ) {
                $iconStack.addClass('hover-on');
                $drawer.addClass('list-container-content-on');
              }

            },
            deactivate: function(row) {
              var $row = $(row),
              $submenu = $row.find(".subcat"),
              $drawer = $sub.find(".dd-drawer"),                
              $iconStack = $row.find(".fa-stack");  

              // Hide the submenu and remove the row's highlighted look
              $submenu.css({ top: "-99999em" });                    
              $row.removeClass("dd-active active-on");

              // change drawer background color back to original
              if ( $row.hasClass('list-container-content') ) {
                $iconStack.removeClass('hover-on');
                $drawer.removeClass('list-container-content-on');
              }                      
            },
            submenuDirection: submenu_direction,
            tolerance: 95  // bigger = LESS forgivey when entering submenu  default: 75        
          }); // menuAim
        } // if drop.find ul   
     
    } // if sub visible
  }; //showSub

  var hideSub = function () {

    var $tab = $(this),
        $sub = $tab.find(".sub"),
        $drop = $sub.find(".category"),
        $dropmenu = $sub.find(".category-drop"),
        $dropli = $drop.find(".category-drop-li"),
        $drawer = $sub.find(".dd-drawer"),
        tab_pos = $tab.position();  
                
    
    $tab.find('.tab').attr('aria-expanded','false');

    $sub.fadeOut(200, function(){
      $(this).removeClass("active").attr('aria-hidden','true');
        //console.log("toggled on"); 
        //console.log('.sub: '+$sub.css('display'))
        //console.log('.category: '+$drop.css('display')+' '+$drop.css('opacity'));
        //console.log('.dd-drawer: '+$sub.find('.dd-drawer').css('display')+' '+$sub.find('.dd-drawer').css('opacity'));        
    });  

      $dropli.removeClass('dd-active active-on');    
      $sub.find('.subcat').css({ top: "-99999em" });
      $dropli.find('.fa-stack').removeClass('hover-on');    
      $drawer.removeClass('list-container-content-on');
      $sub.find( ".category-shadow" ).remove();
      $sub.find( ".drawer-shadow" ).remove();

    
  }; // hideSub()

  var config = {
      sensitivity: 2,
      interval: 200,
      timeout: 200,
      over: showSub,
      out: hideSub
  };

  if ( $('html.lt-ie8').length > 0 ) {
    config = {
      sensitivity: 7,
      interval: 50,
      timeout: 0,
      over: showSub,
      out: hideSub
    };
  }

  $("#topnav.is-megadd li.menu").hoverIntent(config);
  // $("#topnav.is-megadd li:nth-child(1)").find('.sub').show(); //testing purposes

  var megaDDVisible = function () {
      return $("#topnav .sub").is(":visible");
  };

  var megaDDHideAll = function () {
    var $visible_sub = $topnav.find(".sub:visible").first();
    $visible_sub.each(function () {
      var $t = $(this),
        $menu = $t.closest(".menu"),        
        $drop = $t.find(".category"),
        $dropmenu = $t.find(".category-drop"),
        $dropli = $drop.find(".category-drop-li"),
        $drawer = $t.find(".dd-drawer");

      $dropli.removeClass('dd-active active-on');    
      $t.find('.subcat').css({ top: "-99999em" });
      $dropli.find('.fa-stack').removeClass('hover-on');    
      $drawer.removeClass('list-container-content-on');
      $t.find( ".category-shadow" ).remove();
      $t.find( ".drawer-shadow" ).remove();

      

      if ( $t.hasClass('dd-pull-right')) {
        $t.find(".dd-drawer").animate({ right: 0 }, 100).fadeTo( 0, 0 ).addClass('drawer-closed');                         
      }//if dd-pull-right
      else {
        $t.find(".dd-drawer").animate({ left: 0 }, 100).fadeTo( 0, 0 ).addClass('drawer-closed');          
      }//else

      $t.find('.category').slideUp(150);

      $t.find('.fa-stack').removeClass('hover-on');
      $t.find( '.dd-drawer' ).removeClass('list-container-content-on'); //.animate({ submenu_animate_direction: 0 }, 200);            
        
      $t.fadeTo("fast", 0, function () {
          $t.removeClass("active").hide();
      });  
    });  
  };

  var tabsInactive = function () {
    $topnav.each(function () {
      $(this).find("> li").removeClass("active");
    });
  };

  $(document).delegate("form, a", "focus", function (e) {
    if (!$(this).parents("#topnav").length) {
      // handles tabbing out of primary nav
      tabsInactive();
      if (megaDDVisible()) {
        megaDDHideAll();
      }
    }
  });
  
  // KEYBOARD NAV
  $topnav.on("focus", ".tab", function (e) {
    var $t = $(this),
        $menu = $t.closest(".menu");        
        tabsInactive();
        $menu.toggleClass("active");
  })
  .on("keydown", ".tab", function (e) { // 1st Level Links
    kb = true;
    //console.log('kb = '+kb);
    var $t = $(this),
        $menu = $t.closest(".menu"),  
        $first_droplink = $menu.find(".category-drop-li:first > a.nav_bubblelabel"),
        //console.log('focus .tab pressed: '+ e.keyCode);       
        code = (e.keyCode ? e.keyCode : e.which);
    
    switch (code) {    
      case 9: // tab     
        if( e.shiftKey ) {
          if ( megaDDVisible() ) {          
            e.preventDefault();
            hideSub.call($menu);
            $menu.prev('.menu').find(".tab").focus();
            showSub.call($menu.prev('.menu'));
          }          
        }        
      break;

      case 37: // left arrow
        if ( $menu.is('#topnav > li.menu:first-child') ) {
          if ( megaDDVisible() ) {          
            hideSub.call($menu);
            $('#topnav > li:last-child').find(".tab").focus();
            showSub.call($('#topnav > li.menu:last-child'));
          }
          else {          
            $('#topnav > li:last-child').find(".tab").focus();
          }
        }
        else {
          if ( megaDDVisible() ) {          
            hideSub.call($menu);
            $menu.prev('.menu').find(".tab").focus();
            showSub.call($menu.prev('.menu'));
          }
          else {          
            $menu.prev('.menu').find(".tab").focus();
          }
        } 
      break;

      case 38: //up arrow
          e.preventDefault();
        if ( megaDDVisible() ) {          
          hideSub.call($menu);
        }        
      break;

      case 39: // right arrow
      if ( $menu.is('#topnav > li.menu:last-child') ) {
        if ( megaDDVisible() ) {          
          hideSub.call($menu);
          $('#topnav > li:first-child').find(".tab").focus();
          showSub.call( $('#topnav > li:first-child') );
        }
        else {          
          $('#topnav > li:first-child').find(".tab").focus();
        } 
      }
      else {
        if ( megaDDVisible() ) {          
          hideSub.call($menu);
          $menu.next('.menu').find(".tab").focus();
          showSub.call($menu.next('.menu'));
        }
        else {          
          $menu.next('.menu').find(".tab").focus();
        } 
      }
      break;

      case 40: //down arrow
        e.preventDefault();
        if ( megaDDVisible() ) {          
          $first_droplink.focus();
        }
        else {          
          showSub.call($menu);
          setTimeout( function() { $first_droplink.focus(); }, 250);
        }         
      break;

      case 13: // enter
        e.preventDefault();
        if ( megaDDVisible() ) {          
          document.location = $t.attr('href');          
        }
        else {          
          showSub.call($menu);
          //$menu.find('.category-drop-li:first').removeClass('dd-active');
          setTimeout( function() { $first_droplink.focus(); }, 250);
        }                
      break;

      case 32: // space 
          e.preventDefault();               
          showSub.call($menu);
          setTimeout( function() { $first_droplink.focus(); }, 250);        
      break;

      case 27: //esc
        if (megaDDVisible()) {
          var $ddVisible = $t.parents(".menu:first"),
              $activeTab = $ddVisible.find("a.tab:first");
          $activeTab.focus();
          hideSub.call($ddVisible);
          e.preventDefault();
        }
      break;
    }
  })
  .on("focus", ".sub .category .category-drop-li > a.nav_bubblelabel", function (e) { // 2nd Level Links - fire hoverIntent
    var $t = $(this);              
        $t.mouseenter();
  })
  .on("keydown", ".sub .category .category-drop-li > a.nav_bubblelabel", function (e) { // 2nd Level Links
    kb = true;
    //console.log('kb = '+kb);
    var $t = $(this),
        $menu = $t.closest(".menu"),
        $parentDropLink = $t.closest(".category-drop-li"),
        $submenu = $parentDropLink.find(".subcat"),
        $ddVisible = $t.parents(".menu:first"),
        $activeTab = $ddVisible.find("a.tab:first"),      
        code = (e.keyCode ? e.keyCode : e.which);

    switch (code) {  

      case 9: // tab     
        if( e.shiftKey ) {
          e.preventDefault();
          if ( $parentDropLink.is($('li.category-drop-li:first-child')) ) {
            $activeTab.focus();
          }
          else {
            $parentDropLink.prev('.category-drop-li').find("a.nav_bubblelabel")/*.mouseenter()*/.focus();
          }         
        }
        else {
          e.preventDefault();
          if ( $parentDropLink.is($('li.category-drop-li:last-child')) ) {
            hideSub.call($menu);
            $activeTab.closest('.menu').next('.menu').find("a.tab").focus();
            showSub.call($menu.next('.menu'));
          }
          else {
            $parentDropLink.next('.category-drop-li').find("a.nav_bubblelabel")/*.mouseenter()*/.focus();
          }         
        }          
      break;

      case 37: // left arrow                
          if ( $t.closest('.sub').hasClass('dd-pull-right') ) {
            if ( $submenu.length >= 1 ) {
              $submenu.find('.subcat-li a').first().focus();
            }
            else {
              hideSub.call($menu);
              $menu.prev('.menu').find(".tab").focus();
              showSub.call($menu.prev('.menu'));        
            }
          }
          else {
            hideSub.call($menu);
            $menu.prev('.menu').find(".tab").focus();
            showSub.call($menu.prev('.menu'));        
          }
      break;

      case 39: // right arrow
        if ( $t.closest('.sub').hasClass('dd-pull-right') ) {
            hideSub.call($menu);
            $menu.next('.menu').find(".tab").focus();
            showSub.call($menu.next('.menu'));            
          }
          else {
            if ( $submenu.length >= 1 ) {
              $submenu.find('.subcat-li a').first().focus();            
            }
            else {
              hideSub.call($menu);
              $menu.next('.menu').find(".tab").focus();
              showSub.call($menu.next('.menu'));   
            }
          }
      break;

      case 38: //up arrow
          e.preventDefault();
          if ( $parentDropLink.is($('li.category-drop-li:first-child')) ) {
            $activeTab.focus();
          }
          else {
            $parentDropLink.prev('.category-drop-li').find("> a.nav_bubblelabel").mouseenter().focus();
          }
      break;

      case 40: //down arrow
          e.preventDefault();
          if ( $parentDropLink.is($('li.category-drop-li:last-child')) ) {
            hideSub.call($menu);
            $menu.next('.menu').find(".tab").focus();
            showSub.call($menu.next('.menu'));
          }
          else {
            $parentDropLink.next('.category-drop-li').find("> a.nav_bubblelabel").mouseenter().focus();
          }          
      break; 

      case 27: //esc
        if (megaDDVisible()) {
          var $ddVisible = $t.parents(".menu:first"),
              $activeTab = $ddVisible.find("a.tab:first");
          $activeTab.focus();
          hideSub.call($ddVisible);
          e.preventDefault();
        }
      break;
    }
  })
  .on("keydown", ".subcat > ul > li a", function (e) { // 3rd Level Links
      kb = true;
      //console.log('kb = '+kb);
      var $t = $(this),
          $menu = $t.closest(".menu"),
          $parentSubLi = $t.closest("li"),
          $submenu = $t.closest(".subcat"),
          $ddVisible = $t.parents(".menu:first"),
          $activeTab = $ddVisible.find("a.tab:first"),      
          code = (e.keyCode ? e.keyCode : e.which);

      switch (code) {  
        case 9: // tab
          e.preventDefault();
          if ( $parentSubLi.is($('.subcat ul > li:last-child')) ) {
            if ( $submenu.find('.rss').length >= 1 ) {
              //console.log('has rss');
              $submenu.find('.rss a').first().focus();
            }
            else if ( $t.closest('.sub').find('.brief-content a').length >= 1 ) {
              //console.log('has brief-content');
              $t.closest('.sub').find('.brief-content a').first().focus();
            }
            else {
              $t.closest('.category-drop-li').next('li').find(" > a.nav_bubblelabel").mouseenter().focus();
            }
          }
          else {
            $parentSubLi.next('li').find("a").focus();
          }
        break;

        case 37: // left arrow  
          e.preventDefault();              
          if ( $t.closest('.sub').hasClass('dd-pull-right') ) {
            hideSub.call($menu);
            $menu.prev('.menu').find(".tab").focus();
            showSub.call($menu.prev('.menu'));                        
          }
          else {            
              $t.closest('.category-drop-li').find("> a.nav_bubblelabel").mouseenter().focus();
          }
      break;

      case 39: // right arrow
        e.preventDefault();
        if ( $t.closest('.sub').hasClass('dd-pull-right') ) {
          $t.closest('.category-drop-li').find("> a.nav_bubblelabel").mouseenter().focus();                    
        }
        else {           
          hideSub.call($menu);
          $menu.next('.menu').find(".tab").focus();
          showSub.call($menu.next('.menu'));               
        }
      break;

      case 38: //up arrow
          e.preventDefault();
          if ( $t.is( $('.subcat').find('a:first') ) ) {
            $t.closest('.category-drop-li').find("> a.nav_bubblelabel").focus();
          }
          else {
            $parentSubLi.prev('li').find("a").focus();
          }
      break;

      case 40: //down arrow
          e.preventDefault();
          if ( $parentSubLi.is($('.subcat ul > li:last-child')) ) {
            if ( $submenu.find('.rss').length >= 1 ) {
              //console.log('has rss');
              $submenu.find('.rss a').first().focus();
            }
            else if ( $t.closest('.sub').find('.brief-content a').length >= 1 ) {
              //console.log('has brief-content');
              $t.closest('.sub').find('.brief-content a').first().focus();
            }
            else {
              $t.closest('.category-drop-li').next('li').find("> a.nav_bubblelabel").mouseenter().focus();
            }
          }
          else {
            $parentSubLi.next('li').find("a").focus();
          }
      break; 

      case 27: //esc
        if (megaDDVisible()) {
          var $ddVisible = $t.parents(".menu:first"),
              $activeTab = $ddVisible.find("a.tab:first");
          $activeTab.focus();
          hideSub.call($ddVisible);
          e.preventDefault();
        }
      break;
      }
  })
.on("keydown", ".brief-content a", function (e) { // Brief-Content Links
      kb = true;
      //console.log('kb = '+kb);
      var $t = $(this),
          $menu = $t.closest(".menu"),
          $parentSubLi = $t.closest(".sub").find("li.dd-active"),
          $submenu = $parentSubLi.find(".subcat"),
          $ddVisible = $t.parents(".menu:first"),
          $activeTab = $ddVisible.find("a.tab:first"),      
          code = (e.keyCode ? e.keyCode : e.which);

      switch (code) { 
        case 9: //tab
            e.preventDefault();
            if ( $t.is($('.brief-content').find('a:last') ) ) {
              //console.log('brief-content last-of-type');
              if ( $parentSubLi.next('.category-drop-li').length >= 1 ) {                
                $parentSubLi.next('.category-drop-li').find('> a.nav_bubblelabel').focus();
              }
              else {
                if ( $menu.is('#topnav > li.menu:last-child') ) {
                  hideSub.call($menu);
                  $('#topnav >li:first-child').find(".tab").focus();
                  showSub.call($('#topnav >li:first-child'));
                }
                else {
                  hideSub.call($menu);
                  $menu.next('.menu').find(".tab").focus();
                  showSub.call($menu.next('.menu'));
                }
              }
            }
            else {
              $t.next('a').focus();
            }
        break; 

        case 38: //up arrow
          e.preventDefault();
          if ( $t.is( $('.brief-content').find('a').first() ) ) {
            //console.log('brief-content first-of-type');
            $submenu.find("a").last().focus();
          }
          else {
            $t.prev('a').focus();
          }
        break;

        case 40: //down arrow
            e.preventDefault();
            if ( $t.is($('.brief-content').find('a:last') ) ) {
              //console.log('brief-content last-of-type');
              if ( $parentSubLi.next('.category-drop-li').length >= 1 ) {                
                $parentSubLi.next('.category-drop-li').find('> a.nav_bubblelabel').focus();
              }
              else {
                if ( $menu.is('#topnav > li.menu:last-child') ) {
                  hideSub.call($menu);
                  $('#topnav >li:first-child').find(".tab").focus();
                  showSub.call($('#topnav >li:first-child'));
                }
                else {
                  hideSub.call($menu);
                  $menu.next('.menu').find(".tab").focus();
                  showSub.call($menu.next('.menu'));
                }
              }
            }
            else {
              $t.next('a').focus();
            }
        break; 

        case 27: //esc
          if (megaDDVisible()) {
            var $ddVisible = $t.parents(".menu:first"),
                $activeTab = $ddVisible.find("a.tab:first");
            $activeTab.focus();
            hideSub.call($ddVisible);
            e.preventDefault();
          }
        break;      
      }
  })
  .on("keydown", ".rss a", function (e) { // RSS Links
      kb = true; 
      //console.log('kb = '+kb);
      var $t = $(this),
          $menu = $t.closest(".menu"),
          $parentSubLi = $t.closest(".sub").find("li.dd-active"),
          $submenu = $parentSubLi.find(".subcat"),
          $ddVisible = $t.parents(".menu:first"),
          $activeTab = $ddVisible.find("a.tab:first"),      
          code = (e.keyCode ? e.keyCode : e.which);

      switch (code) { 
        case 38: //up arrow
          e.preventDefault();
          if ( $t.is( $('.rss').find('a').first() ) ) {
            //console.log('rss first-of-type');
            $submenu.find("li").last().find("a").focus();
          }
          else {
            $t.prev('a').focus();
          }
        break;

        case 40: //down arrow
            e.preventDefault();
            if ( $t.is( $('.rss a').eq(1) ) ) {
             // console.log('rss last-of-type');
              if ( $t.closest('.sub').find('.brief-content a').length >= 1 ) {
              //  console.log('has brief-content');
                $t.closest('.sub').find('.brief-content a').first().focus();
              }
              else {
                if ( $parentSubLi.next('.category-drop-li').length >= 1 ) {                
                  $parentSubLi.next('.category-drop-li').find('> a.nav_bubblelabel').focus();
                }
                else {
                  if ( $menu.is('#topnav > li.menu:last-child') ) {
                    hideSub.call($menu);
                    $('#topnav >li:first-child').find(".tab").focus();
                    showSub.call($('#topnav >li:first-child'));
                  }
                  else {
                    hideSub.call($menu);
                    $menu.next('.menu').find(".tab").focus();
                    showSub.call($menu.next('.menu'));
                  }
                }
              }
            }
            else {
              $t.next('a').focus();
            }
        break; 

        case 27: //esc
          if (megaDDVisible()) {
            var $ddVisible = $t.parents(".menu:first"),
                $activeTab = $ddVisible.find("a.tab:first");
            $activeTab.focus();
            hideSub.call($ddVisible);
            e.preventDefault();
          }
        break;      
      }
  });

  $('body').click(function(e){
         if( kb == true && e.target.id !== "nav" && !$(e.target).parents('#nav').length )
            {            
              //console.log('kb = true, target.id != nav, !target.parents#nav');
              tabsInactive();
              if (megaDDVisible()) {
                megaDDHideAll();
              } 
              kb = false;
            }
         else
            { 
              //return false;
            }

   });

  // MEGA MENU END

  // 021213KB accessibility adjustment
  // http://css-tricks.com/convert-menu-to-dropdown/
  var $nav = $(".megadd"),
      $menu = $("<div id='mobile-menu' class='col col12'></div>"),
      $label = $("<label for='mobile-select'><span style='display: none;'>Main Navigation</span></label>"),
      $select = $("<select id='mobile-select'></select>"),
      $option = $("<option selected='selected' value=''>Main Menu</option>"),
      selectPath = "#mobile-select";

  $menu.prependTo($nav);
  $label.appendTo($menu);
  $select.appendTo($menu);
  $option.appendTo($(selectPath));

  $("#topnav > li").each(function() {
    var $el = $(this);
    var menuAnchor = $(this).find("a:first");
    $("<option />", {
      "value"   : menuAnchor.attr("href"),
      "text"    : menuAnchor.text()
    }).appendTo($(selectPath));
  });

  $("<button>Go</button>").click(function(){
    window.location = $(selectPath).find("option:selected").val();
  }).insertAfter($(selectPath));

  //lost toggle on / off button func. if needed - recreate

}); // noconflict end