// v.20131031
// Avoid `console` errors in browsers that lack a console.
if (!(window.console && console.log)) {
    (function() {
        var noop = function() {};
        var methods = ['assert', 'clear', 'count', 'debug', 'dir', 'dirxml', 'error', 'exception', 'group', 'groupCollapsed', 'groupEnd', 'info', 'log', 'markTimeline', 'profile', 'profileEnd', 'markTimeline', 'table', 'time', 'timeEnd', 'timeStamp', 'trace', 'warn'];
        var length = methods.length;
        var console = window.console = {};
        while (length--) {
            console[methods[length]] = noop;
        }
    }());
}
//01112013KB
function getParameterByName(name) {
// http://james.padolsey.com/javascript/bujs-1-getparameterbyname/
    var match = RegExp('[?&]' + name + '=([^&]*)')
                    .exec(window.location.search);
    return match ?
        decodeURIComponent(match[1].replace(/\+/g, ' '))
        : null;
}


// 012913 MOBILE
jQuery(document).ready(function ($) {
  //PLACE ANY jQUERY HELPERS / PLUGINS HERE

  // LT-IE8 SEARCH MAGNIFY FALLBACK due to lack of css :before support
  $('<img class="lt-ie8-magnify" src="/resources/images/template/search-left.png" alt="" />').insertBefore('.lt-ie8 #searchinput');

  // AUTOCOMPLETE GSA SUGGEST
  // http://jqueryui.com/demos/autocomplete/#remote-jsonp
  var gsaForm = $("form[role=search]"),
    gsaSite = $(":input[name=site]", gsaForm).val(),
    gsaClient = $(":input[name=client]", gsaForm).val();

  $(":input[name=q]", gsaForm).autocomplete({
    position: { my : "right top", at: "right bottom" },
    minLength: 1,
    source: function( request, response ) {
      // console.log(request.term);
      $.ajax({
        // url: "http://170.63.97.168/suggest",
        // url: "http://146.243.30.38/suggest",
        url: "http://search.mass.gov/suggest",
        dataType: "jsonp",
        data: {
          q: request.term,
          max: 8,
          site: gsaSite,
          client: gsaClient,
          access: "p",
          format: "os"
        },
        success: function( data ) {
          response(data[1]); //GSA results
        }
      });
    },
    select: function( e, ui ) {
      $(this).val(ui.item.value).closest("form").submit();
    }
  });

  // INPUT[TEXT] HINT
  $.fn.hint = function () {
    $(this).each(function () {
      $(this).val($(this).attr("title")).addClass("hint");
    });

    return $(this).focus(function () {
        if ($(this).val() === $(this).attr("title")) {
          $(this).val("").removeClass("hint");
        }
      }).blur(function () {
        if ($(this).val() === "") {
          $(this).val($(this).attr("title")).addClass("hint");
        }
      });
  };
  $("input[title]").hint();

  // PRIMARY SEARCH VALIDATION
  $('form.search').submit(function (e) {
    var $input = $(this).find('[type="text"]');
    if ( $input.val() === "" || $input.val() === $input.attr("title") ) {
      e.preventDefault();
      alert("Please enter a search term.");
    }
  });

  // TOGGLE SIDEBAR MENU
  $(".toggle_container").hide();
  $(".trigger .button").click(function (e) {
    e.preventDefault();
    $(this).closest(".trigger").toggleClass("active").find(".toggle_container").slideToggle("fast");
  });

  //toggle colors for debug
  //01112013KB
  if (getParameterByName('debug')) {
    $('body').addClass("debug");
  };
  
	// documnet icon display with inline links - 9/20/2013 YG
	$('.content a:not([class])').each(function(index, value){// screen inline links in a body content area
		var currentpage = window.location.pathname;
		var filtered_site = "/edu/";
    if( $(this).attr("href") )  {
  		if( currentpage.indexOf(filtered_site) == -1 ) {// filter links in edu
  			var $iconLocation = "http://www.mass.gov/resources/images/template/";// icon location folder
  			if( $(this).attr('href').match(/\.doc$/) || $(this).attr('href').match(/\.docx$/) ||  $(this).attr('href').match(/\.docm$/) ) {
  				var $wordIcon = ' <img src="' + $iconLocation + 'icon_doc_doc.png" alt="links to Word file" border="0" />';
  				$(this).append($wordIcon);
  			} else if( $(this).attr('href').match(/\.xls$/) || $(this).attr('href').match(/\.xlsx$/) ||  $(this).attr('href').match(/\.xlsm$/) ) {
  				var $excelIcon = ' <img src="' + $iconLocation + 'icon_doc_xls.png" alt="links to Excel file" border="0" />';
  				$(this).append($excelIcon);// excel
  			} else if( $(this).attr('href').match(/\.pdf$/) ) {
  				var $pdfIcon = ' <img src="' + $iconLocation + 'icon_doc_pdf.png" alt="links to PDF file" border="0" />';
  				$(this).append($pdfIcon);// pdf
  			} else if( $(this).attr('href').match(/\.rtf$/) ) {
  				var $rtfIcon = ' <img src="' + $iconLocation + 'icon_doc_rtf.png" alt="links to Rich Text Format file" border="0" />';
  				$(this).append($rtfIcon);// rtf
  			} else if( $(this).attr('href').match(/\.txt$/) ) {
  				var $textIcon = ' <img src="' + $iconLocation + 'icon_doc_txt.png" alt="links to Text file" border="0" />';
  				$(this).append($textIcon);// text
  			} else if( $(this).attr('href').match(/\.ppt$/) || $(this).attr('href').match(/\.pptx$/) ||  $(this).attr('href').match(/\.pptm$/) ) {
  				var $pptIcon = ' <img src="' + $iconLocation + 'icon_doc_ppt.png" alt="links to Powerpoint file" border="0" />';
  				$(this).append($pptIcon);// PowerPoint
  			} else if( $(this).attr('href').match(/\.zip$/) ) {
  				var $zipIcon = ' <img src="' + $iconLocation + 'icon_doc_zip.png" alt="links to Zip file" border="0" />';
  				$(this).append($zipIcon);// ZIP
  			} else if( $(this).attr('href').match(/\.wav$/) || $(this).attr('href').match(/\.wma$/) ||  $(this).attr('href').match(/\.mp3$/) ||  $(this).attr('href').match(/\.rm$/) ) {
  				var $audioIcon = ' <img src="' + $iconLocation + 'icon_doc_audio.png" alt="links to Audio file" border="0" />';
  				$(this).append($audioIcon);// audio
  			} else if( $(this).attr('href').match(/\.avi$/) || $(this).attr('href').match(/\.wmv$/) ||  $(this).attr('href').match(/\.mpg$/) ||  $(this).attr('href').match(/\.mov$/) ||  $(this).attr('href').match(/\.rm$/) ||  $(this).attr('href').match(/\.ram$/) ) {
  				var $movieIcon = ' <img src="' + $iconLocation + 'icon_doc_movie.png" alt="links to Movie file" border="0" />';
  				$(this).append($movieIcon);// movie
  			};
      };// filter for href
		};// filter edu
	});// .each()
	
	//  client override for ER191 - 10/31/2013 YG
	$("form.search select").change(function() {
		var attributeCheck = $("form.search select option:selected").attr("data-frontend");
		var clientValue = $('input[name="client"]').val();
		var optionValue = $("form.search option:selected").attr("data-frontend");
		if ( typeof attributeCheck != 'undefined' && attributeCheck != false) {
			if (clientValue != optionValue) {
				var newOptionValue = $("form.search option:selected").attr("data-frontend");
				$('input[name="client"]').val(newOptionValue);
			};
		} else {
			defaultValue = $("form.search select option:first-child").attr("data-frontend")
			$('input[name="client"]').val(defaultValue);
		};
	});
  //
});// noconflict end  