// 01142013 KB
var MAGOV = window.MAGOV = window.MAGOV || {}; //namespace custom scripts

jQuery(document).ready(function ($) {

  "use strict";

  //fitVids plugin for YT, iframe embeds
  $(".container").fitVids();

  // 01112013 resize gmap makes sure to retain the initial
  // aspect ratio of an embeded gmap iframe
  // due to rwd resizing
  // a better soln'? http://stackoverflow.com/questions/12676725/responsive-iframe-google-maps-and-weird-resizing
  window.MAGOV.resizeGmap = {
    $gmap: $('iframe[src*="maps.google.com"]'),
    gW: 0,
    gH: 0,
    ar: 0,

    initialize: function() {
      if (MAGOV.resizeGmap.$gmap.length) {
        // $(window).resize(MAGOV.resizeGmap.listen).resize();
        $(window).on('resize load', MAGOV.resizeGmap.listen);
        MAGOV.resizeGmap.gW = MAGOV.resizeGmap.$gmap.attr('width');
        MAGOV.resizeGmap.gH = MAGOV.resizeGmap.$gmap.attr('height');
        MAGOV.resizeGmap.ar = MAGOV.resizeGmap.gW / MAGOV.resizeGmap.gH;
      }
    },

    listen: function() {
      var new_h = Math.round(MAGOV.resizeGmap.$gmap.width() * MAGOV.resizeGmap.ar);
      MAGOV.resizeGmap.$gmap.height(new_h);
    }
  };
  MAGOV.resizeGmap.initialize();

  // 01092013 KB - Rewrite of Slideshow Resize Function
  // resize standard slideshow for alternate mobile views, reference responsive-slideshow.css
  // Golden ratio: 2:1 946x473 xlarge, 696x348 large, 462x231 medium, 302x151 small
  // use initialWidths to ensure that 302 sizes don't get scaled up
  window.MAGOV.resizeSS = {
    $maSlideshows: $('.ma_slideshow'),

    initialize: function() {
      $(window).on('resize load', MAGOV.resizeSS.listen);
      // $(window).resize(MAGOV.resizeSS.listen).resize();

      MAGOV.resizeSS.$maSlideshows.each( function(idx, elem) {
        $(elem).data('iW', $(elem).width());
      });
    },

    listen: function() {
      MAGOV.resizeSS.$maSlideshows.each( function(idx, elem){
        var $ss = $(elem),
            ss_w = $ss.width(),
            col_w = $ss.parents('.col:first').width(),
            initWidth = $ss.data('iW'),
            ss_sizes = {'col946' : 946, 'col696' : 696, 'col462' : 462, 'col302' : 302 };

        if (col_w > ss_sizes.col946 && initWidth >= ss_sizes.col946) {
          $ss.removeClass("col946 col696 col462 col302").addClass("col946");
        }
        else if (ss_sizes.col696 < col_w && col_w < ss_sizes.col946 && initWidth >= ss_sizes.col696) {
          $ss.removeClass("col946 col696 col462 col302").addClass("col696");
        }
        else if (ss_sizes.col462 < col_w && col_w < ss_sizes.col696 && initWidth >= ss_sizes.col462) {
          $ss.removeClass("col946 col696 col462 col302").addClass("col462");
        }
        else if ( initWidth >= ss_sizes.col302) {
          $ss.removeClass("col946 col696 col462 col302").addClass("col302");
        }
      });
    }

  };
  MAGOV.resizeSS.initialize();

// 20141201 tabbed module
// keep all tabs same height even on window resize
  window.MAGOV.resizeTabs = {
    $maTabs: $('.ma-tabs'),

    initialize: function() {
      $(window).on('resize', MAGOV.resizeTabs.listen);
    },

    listen: function() {

      MAGOV.resizeTabs.$maTabs.each( function() {
          var currentTallest = (currentTallest) ? currentTallest : 0,
                 selectedHeight = (selectedHeight) ? selectedHeight : 0,
                 $el = $(this).find('.tab-control li'), //.not('tabs-selected'),
                 $selected = $(this).find('.tab-control li.tabs-selected');


           $el.each(function(idx) {
              $(this).css("height", "auto");
              if ( $(this).height() > currentTallest ) { currentTallest = $(this).height(); }
           });
          $el.height(currentTallest);
           selectedHeight = currentTallest + 4;
           $selected.height(selectedHeight);

      });
    }
  };

   var oldIEFlag = $('html').hasClass('lt-ie9');
   if (!oldIEFlag) { MAGOV.resizeTabs.initialize(); }


  // 02112013 RESPONSIVE TABLES *containers fix
  MAGOV.rTables = {
    $tables: $('table', '.content'),
    $containers: $('.outer-container, .alert-container'), //applies RWD
    tableData: [],
    imageData: [],
    pageYOffset: 0,

    initialize: function() {
      MAGOV.rTables.$tables.each( function( idx, elem ) {
        MAGOV.rTables.tableData[idx] = {
                                        'initWidth': $(elem).width(),
                                        'parentWidth': $(elem).parent().width(),
                                        '$elem': $(elem),
                                        'display': 1
                                      };
        MAGOV.rTables.imageData[idx] = {
                                        'parentWidth': 0,
                                        '$elem': {},
                                        'display': 0
                                      };
      });
      // $(window).resize(MAGOV.rTables.listen).resize();
      $(window).on('resize load', MAGOV.rTables.listen);
    },

    listen: function() {

      MAGOV.rTables.$tables.each( function( idx, elem ) {
        var tableData = MAGOV.rTables.tableData[idx],
            imageData = MAGOV.rTables.imageData[idx];

        // update parentWidth based on resize
        if ($(elem).parent().width() !== null) {
          // tableData[idx] has been yanked from DOM
          tableData.parentWidth = $(elem).parent().width();
        } else {
          // get imageData[idx] parentWidth
          imageData.parentWidth = tableData.parentWidth = imageData.$elem.parent().width();
        }

        MAGOV.rTables.overflowTrigger(idx);

      });
    },

    overflowTrigger: function(idx) {
      var tableData = MAGOV.rTables.tableData[idx],
          imageData = MAGOV.rTables.imageData[idx],
          parentWidth = tableData.parentWidth || imageData.parentWidth;

      if (tableData.display === 1 && tableData.initWidth > parentWidth) {
        MAGOV.rTables.makeResponsive(idx);
      }
      if (imageData.display === 1 && tableData.initWidth <= parentWidth) {
        MAGOV.rTables.reset(idx);
      }
    },

    makeResponsive: function(idx) {
      var tableData = MAGOV.rTables.tableData[idx],
          imageData = MAGOV.rTables.imageData[idx];

      imageData.$elem = $('<img class="rtimg" data-tbl-idx=' + idx + ' src="/resources/images/rtbl.png" alt="Table: Tap to View" />');

      tableData.$elem.addClass('rtbl').replaceWith(imageData.$elem, ".content"); //context

      //flip table & image display bit
      tableData.display = 0;
      imageData.display = 1;

      //render responsive table
      imageData.$elem.click(function(e) {
        MAGOV.rTables.pageYOffset = window.pageYOffset; //set scrollpoint for #back
        MAGOV.rTables.loadTable( idx );
      });
    },

    loadTable: function(idx) {
      var tableData = MAGOV.rTables.tableData[idx],
          imageData = MAGOV.rTables.imageData[idx];

      tableData.$elem.prependTo('body');
      window.scroll(0, 0); //otherwise it won't go to the top of the table

      // hide containers
      MAGOV.rTables.$containers.hide();

      // handle back button
      MAGOV.rTables.bindBack(idx);
    },

    bindBack: function(idx) {
      var tableData = MAGOV.rTables.tableData[idx],
          imageData = MAGOV.rTables.imageData[idx];

      var $returnBtn = $('<a href="#" id="back">return to page</a>');

      var resetView = function() {
        $returnBtn.next().remove() //get rid of inserted table .detach() ?
                  .end().remove(); //remove #back button
        MAGOV.rTables.$containers.show();
        window.scroll(0, MAGOV.rTables.pageYOffset); //reset scrollpoint
      };

      $returnBtn.prependTo('body').click( function(e) {
        e.preventDefault();
        resetView();
      });
    },

    reset: function(idx) {
      var tableData = MAGOV.rTables.tableData[idx],
          imageData = MAGOV.rTables.imageData[idx];

      tableData.$elem.removeClass('rtbl');
      imageData.$elem.replaceWith(tableData.$elem);

      tableData.display = 1;
      imageData.display = 0;
    }

  };
  MAGOV.rTables.initialize();

  // 012213KB - only targets search page #iFrame
  // http://npr.github.com/responsiveiframe/
  $('#iFrame').responsiveIframe({ xdomain: '*'});

  // http://adactio.com/journal/4470/ avoids iPad orientation switch zoom issue
  if (navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPad/i)) {
    var viewportmeta = document.querySelector('meta[name="viewport"]');
    if (viewportmeta) {
      viewportmeta.content = 'width=device-width, minimum-scale=1.0, maximum-scale=1.0';
      document.body.addEventListener('gesturestart', function() {
        viewportmeta.content = 'width=device-width, minimum-scale=0.25, maximum-scale=1.6';
      }, false);
    }
  }

  // remove height/width attrs for responsiveness, get this out of Velocity templates
  $('img').removeAttr('height').removeAttr('width');

});
