/*************************************************************** 
 Massgov V101.1352.20140731 
 Deployed from Git Branch: feature/ER214_ER64_recommendations_history 
 Last Commit: 4837206 at "2014-09-12 12:08:00 -0400"
 Change made by "Jes Constantine" (jessica.constantine@state.ma.us)
****************************************************************/

/***************************************************************
 Massgov V101.1352.20140731
 Deployed from Git Branch: feature/ER214_ER64_recommendations_history
 Last Commit: b39cd73 at "2014-08-27 15:35:20 -0400"
 Change made by "Jes Constantine" (jessica.constantine@state.ma.us)
****************************************************************/

/**********************************************************
	Tracking.js
	Tracks Translate events, outgoing link events,
	+ non htm/l filetype downloads (virtual pageView)

     V062014 for C1011013 - add event tracking for recommendation engine
	V071713.1 - content author customVar removed
	from this file and added to global template head js

***********************************************************/


(function($) {

  //071713JC author custom variable tracking moved to global template <head> with standard pageview tracking

 //072814JC track any clicks in recommendation module -- created new function because recs are triggered on click
 $.fn.trackRecs = function(event) { // http://goo.gl/YY4Yg Event Tracker Guide, goo.gl/NoItB multiple trackers
         if ( $(this).hasClass("bn-link") && window._gaq) {
            //console.log('.bn-link');

            var url = $(this).attr('href');
               //console.log('found one');
               // preventDefault triggering error in IE7/8 - http://goo.gl/D6NWMS
               event.preventDefault ? event.preventDefault() : event.returnValue = false;

               // determine if recommendation link was from recommendation, personal history, or a toggle / privacy link
               var recOrHistory = 'toggle or privacy link',
                    sidebarOrCenter = 'Recommendation Click - Center';
               if ( $(this).parents('#bn-home-recs-personalized').length != 0 || $(this).parents('#bn-sidebar-recs-personalized').length != 0 || $(this).parents('#bn-footer-recs-personalized').length != 0 ) {
                  recOrHistory = 'recommended content - personalized';
                }
                if ( $(this).parents('#bn-home-recs-crowdsourced').length != 0 || $(this).parents('#bn-sidebar-recs-crowdsourced').length != 0 || $(this).parents('#bn-footer-recs-crowdsourced').length != 0 ) {
                  recOrHistory = 'recommended content - crowdsourced';
                }
               if ( $(this).parents('.bn-history').length != 0 ) {
                  recOrHistory = 'personal history';
               }
               if ( $(this).parents('.leftcol').length > 0 || $(this).parents('.resources').length > 0 ) {
                  sidebarOrCenter = 'Recommendation Click - Sidebar';
               }

               // send event to GA
               _gaq.push(
                  ['_trackEvent', sidebarOrCenter, recOrHistory, url, 0, true],
                  ['b._trackEvent', sidebarOrCenter, recOrHistory, url, 0, true]
                  );

               // redirect
               setTimeout('document.location = "' + url + '"', 100);

            }
  };

  //082912KB trackPls
  //011713KB multiple tracking.js confusion
  $.fn.trackPls = function () { // http://goo.gl/YY4Yg Event Tracker Guide, goo.gl/NoItB multiple trackers
        var url = this.attr("href"),
          //agency whitelist
          internalHrefRgx = /^((http:\/\/)?(www.)?mass.gov)?\/(portal|ago|alert|anf|auditor|berkshireda|childadvocate|courts|dor|dppc|edu|eea|elders|eohhs|eopss|essexda|essexsheriff|ethics|gaming|governor|hdc|hed|hqcc|ig|informedma|investors|itdemployee|lwd|mdaa|mova|msa|ocabr|osc|pca|portal|recovery|transparency|treasury|veterans|women)(\/.*)?$/i;

      	// 060713JC track any Translation Disclaimer "accept" clicks @ /portal/translationdisclaimer.html -- skips outgoing link event
      	if (url.match(/^https?:\/\/([^/]*\.)?microsofttranslator\.com(\/.*|$)/i)) {
      		this.click(function(e){
      			e.preventDefault();

      			//get link and language from querystring
      			function getUrlVars()
      			  {
      				  var vars = [], hash;
      				  var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
      				  for(var i = 0; i < hashes.length; i++)
      				  {
      					  hash = hashes[i].split('=');
      					  vars.push(hash[0]);
      					  vars[hash[0]] = hash[1];
      				  }
      				  return vars;
      			  }

      			var to_language = getUrlVars()["to"];

                              var languages = {
                                 'ar': 'Arabic',
                                 'bg': 'Bulgarian',
                                 'ca': 'Catalan',
                                 'zh-chs': 'Chinese (Simplified)',
                                 'zh-cht': 'Chinese (Traditional)',
                                 'cs': 'Czech',
                                 'da': 'Danish',
                                 'nl': 'Dutch',
                                 'en': 'English',
                                 'et': 'Estonian',
                                 'fa': 'Persian (Farsi)',
                                 'fi': 'Finnish',
                                 'fr': 'French',
                                 'de': 'German',
                                 'el': 'Greek',
                                 'ht': 'Haitian Creole',
                                 'he': 'Hebrew',
                                 'hi': 'Hindi',
                                 'hu': 'Hungarian',
                                 'id': 'Indonesian',
                                 'it': 'Italian',
                                 'ja': 'Japanese',
                                 'ko': 'Korean',
                                 'lv': 'Latvian',
                                 'lt': 'Lithuanian',
                                 'ms': 'Malay',
                                 'mww': 'Hmong Daw',
                                 'no': 'Norwegian',
                                 'pl': 'Polish',
                                 'pt': 'Português',
                                 'ro': 'Romanian',
                                 'ru': 'Russian',
                                 'sk': 'Slovak',
                                 'sl': 'Slovenian',
                                 'es': 'Spanish',
                                 'sv': 'Swedish',
                                 'th': 'Thai',
                                 'tr': 'Turkish',
                                 'uk': 'Ukrainian',
                                 'ur': 'Urdu',
                                 'vi': 'Vietnamese'
                              };

                              //console.log(languages);

                              var language = languages[to_language];
                              //console.log(language);

      			var translate_page = decodeURIComponent(getUrlVars()["a"]);

      			//create event for translation with category "translation", Action: language, and Label: url
                      _gaq.push(
                        ['_trackEvent', 'Translation', language, translate_page, 0, true],
                        ['b._trackEvent', 'Translation', language, translate_page, 0, true]
                        );
      			setTimeout('document.location = "' + this.href + '"', 100);
      		});
      	}

        var getFiletype = function(string){
          var lastPeriod = string.lastIndexOf('.') + 1, //char after .
              length = string.length,
              diff = length - lastPeriod;
          if (lastPeriod > 0 && diff <=5) {
            return string.substring(lastPeriod,length);
          }
        };

        var filetype = getFiletype(url);

        if ( url.match(internalHrefRgx) && filetype != 'htm' && filetype != 'html' && filetype) {
          // if an INTERNAL url with a file extension is clicked that is NOT htm|l or ends with "/" or just a hanging directory url like /portal it is considered a download
          this.click(function(e){
            e.preventDefault();

            //virtual pageview test goo.gl/Ip660
            var virtual = $(this).attr('href');
            _gaq.push(['_trackPageview', virtual]);
            _gaq.push(['b._trackPageview', virtual]);

            // honor link with target attribute set to "_blank" (not the most accessible, but fix requested 7/2013)
            if (this.target == "_blank") {
            	window.open(this.href);
            }
            else {
            	setTimeout('document.location = "' + this.href + '"', 100);
            }
          });


        } else if (!url.match(internalHrefRgx) && !url.match(/(^mailto:)|(^javascript:)|(^\#)/i)){
          // if internal link regex is not matched, a link is considered "outgoing" &&
          // if external link does not start with '#', '#words', 'mailto:', 'javascript:' (case insensitive) then it counts as an external link click
          this.click(function(e){
            e.preventDefault();

            /**
            * Fires an artificial visit event and page event for the target document. This
            * is intended to observe title attributes for documents with no observer tag.
            *
            * @param url the URL of the target document (<a href>)
            * @param clicked the <a> element associated with the click

            * function bn_fireEvents(url, clicked) {}

            */

            if (typeof bn_fireEvents == 'function') {
                  try {
                     bn_fireEvents(e.target.href, e.target);
                  }
                  catch (error) {
                     // statements to handle any exceptions
                     window.console && console.log('baynote error: ' + error); // pass exception object to error handler
                  }
              }

            _gaq.push(['b._trackEvent', 'Outgoing Link', 'Click', url, 0, true]);
            var outgoing = "/outgoing/" + $(this).attr('href').replace(/(http(s)?:\/\/)?(\/)?/i, "");
            _gaq.push(['b._trackPageview', outgoing]);

            // honor link with target attribute set to "_blank" (not the most accessible, but fix requested 7/2013)
            if (this.target == "_blank") {
            	window.open(this.href);
            }
            else {
            	setTimeout('document.location = "' + this.href + '"', 250);
            }
          });
        }
        return this;

  };

})(jQuery);
